#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    long long n, q; cin >> n >> q;
    string niska; cin >> niska;
    while (q--) {
        long long l, r; cin >> l >> r;
        cout << (r - l + 1) * (r - l + 1) / 4 << "\n";
    }

    return 0;
}